#include <iostream>
using namespace std;
int main()
{
	int n,k;
	cin>>n>>k;
	int a[n][n];
    double levo,desno,gore,dole;
	for(int i=0;i<n;i++)
	{
		for(int j=0;j<n;j++)
		{
			cin>>a[i][j];
		}
	}
	int brojac=0;
	for(int m=1;m<=k;m++)
	{
		gore=-1;
		dole=-1;
		desno=-1;
		levo=-1;
		for(int i=0;i<n;i++)
		{
			for(int j=0;j<n;j++)
			{
				if(a[i][j]==m)
				{
					gore=i;
					break;
				}
			}
			if(gore!=-1)
			{
				break;
			}
		}
		for(int i=0;i<n;i++)
		{
			for(int j=0;j<n;j++)
			{
				if(a[j][i]==m)
				{
					levo=i;
					break;
				}
			}
			if(levo!=-1)
			{
				break;
			}
		}
		for(int i=(n-1);i>=0;i--)
		{
			for(int j=0;j<n;j++)
			{
				if(a[i][j]==m)
				{
					dole=i;
					break;
				}
			}
			if(dole!=-1)
			{
				break;
			}
		}
		for(int i=n-1;i>=0;i--)
		{
			for(int j=0;j<n;j++)
			{
				if(a[j][i]==m)
				{
					desno=i;
					break;
				}
			}
			if(desno!=-1)
			{
				break;
			}
		}
		bool x=true;
		for(int i=gore;i<=dole;i++)
		{
			for(int j=levo;j<=desno;j++)
			{
				if(a[i][j]!=m)
				{
					x=false;
					break;
				}
			}
			if(x==false)
			{
				break;
			}
		}
		if(x==true)
		{
			brojac++;
		}
	}
	cout<<brojac;
}